/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2017 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technoledge Corp. 
//  Website: http://www.nuvoton.com
//  E-Mail : MicroC-8bit@nuvoton.com
//  Date   : Apr/21/2017
//***********************************************************************************************************

//***********************************************************************************************************
//  File Function: N76E003 wake up timer interrupt demo code
//***********************************************************************************************************
#include "N76E003.h"
#include "Common.h"
#include "Delay.h"
#include "SFR_Macro.h"
#include "Function_define.h"


uint16_t time_cal[2],time_30Min;
uint8_t time_step,time_1s;

uint32_t time_cum;


void WakeUp_Timer_ISR (void) using 1  interrupt 17     //ISR for self wake-up timer
{
    uint32_t temp;
	  if(time_step==0)
	  {//  enter per sec
		 TA=0xAA;TA=0x55;CKEN|=SET_BIT5;
		 while((CKSWT&SET_BIT5)==0);				//check HIRC ready
		 TA=0xAA;TA=0x55;CKSWT&=~SET_BIT2;			//switching system clock source to HIRC
		 while((CKEN&SET_BIT0)==1);
		 
         TIMER0_MODE1_ENABLE;
         set_T0M;		  
         TH0 = 0;
         TL0 = 0;
		 WKCON = 0x00; 								//timer base 10k, Pre-scale = 1/1
		 RWK   = 256-2; 
		 WKCON |=  0x18;
		 set_TR0;
		 time_step = 1;
		 
		 time_30Min++;
         if(time_30Min>=1)//1800 sec
         {
			 P12 = ~P12;
			 time_30Min = 0;
         } 
	  }  
	  else if(time_step==1)
	  {
		 time_cal[0]  = TL0;
	     time_cal[0] |= TH0<<8; 
		 time_step = 2;
	  }  
	  else if(time_step==6)
	  {
		 clr_TR0;
		 time_cal[1]  = TL0;
	     time_cal[1] |= TH0<<8;
		 time_cal[1] -= time_cal[0];
		 if(time_cal[1]>=16000)
		 {
			  time_cal[1] = time_cal[1]-16000;
			  temp = (uint32_t)time_cal[1]*15625+time_cum;
			  time_1s = 156 - temp/1600000;
			  time_cum = temp%1600000;
         }			  
		 else
		 {
			  time_cal[1] = 16000 - time_cal[1];
			  temp = (uint32_t)time_cal[1]*15625+time_cum;
			  time_1s = 156 + temp/1600000;
			  time_cum = temp%1600000;
		 }			  
		 WKCON = 0x03;
		 RWK   = 256-time_1s;
		 WKCON |=  0x18;
		 time_step=0;  
	  }
	  else time_step ++;
	  
	  clr_WKTF;                    		           //clear interrupt flag
}


/************************************************************************************************************
*    Main function 
************************************************************************************************************/
void main (void)
{
        Set_All_GPIO_Quasi_Mode;
//-----------------------------------------------------
//	WKT initial 	
//-----------------------------------------------------	
        WKCON = 0x03; 										//timer base 10k, Pre-scale = 1/64
		RWK   = 256-156;                                    //1Hz
	    set_PWKT;
		set_PWKTH;
        set_EWKT;										    // enable WKT interrupt
		set_WKTR; 											// Wake-up timer run 
		EA = 1;
		while(1)
		{
			if(time_step==0)
			{
			  set_OSC1;									//switching system clock source to LIRC
		      while((CKEN&SET_BIT0)==1);				//check system clock switching OK or NG 	
		      clr_HIRCEN;
			  set_IDL;                                  //enter IDL mode
            }				
		}
}

